import 'dart:io';

import 'package:imsdk_client_core/imsdk_client_core.dart';

void main() {
  validateAppLocalizations();
}

void validateAppLocalizations() {
  final logger = EasyLogger();
  final file = File('${Directory.current.path}/lib/app/app_locale.dart');
  final codeLines = file.readAsLinesSync();
  final fields = <String>[];
  int i = 1;
  for (var line in codeLines) {
    final item = line.trim();
    if (item.startsWith('static String get') && item.endsWith(']!;')) {
      final fd1 = item.substring(item.indexOf('get') + 3, item.indexOf('=>')).trim();
      final fd2 = item.substring(item.indexOf('[') + 2, item.indexOf(']!;') - 1);
      if (fd1 != fd2) {
        logger.logError([i, fd1, '!=', fd2]);
        return;
      } else {
        fields.add(fd1);
      }
      i++;
    }
  }
  const mapSplit = 'static final Map<String, Map<String, String>> _localizedValues =';
  final codeAll = file.readAsStringSync();
  final mapStart = codeAll.indexOf(mapSplit) + mapSplit.length;
  final mapEnd = codeAll.indexOf(';', mapStart);
  final codeString = codeAll.substring(mapStart, mapEnd);
  // logger.logInfo([codeString]);
  i = 1;
  for (var fd in fields) {
    final firstIndex = codeString.indexOf(fd);
    final lastIndex = codeString.lastIndexOf(fd);
    if (firstIndex < 0 || lastIndex < 0 || firstIndex == lastIndex) {
      logger.logError([i, fd, firstIndex, lastIndex]);
      return;
    } else {
      logger.logDebug([i, fd, firstIndex, lastIndex]);
    }
    i++;
  }
  logger.logInfo(['success', fields.length]);
}
